/*
 * Copyright (c) 2013, Linz Center of Mechatronics GmbH (LCM), web: www.lcm.at
 * All rights reserved.
 */
/*
 * This file is licensed according to the BSD 3-clause license as follows:
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the "Linz Center of Mechatronics GmbH" and "LCM" nor
 *       the names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL "Linz Center of Mechatronics GmbH" BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * This file is part of X2C. web: x2c.lcm.at
 * $LastChangedRevision: 4457 $
 * $LastChangedDate:: 2026-08-13 18:59:23 +0200#$
 */
/* USERCODE-BEGIN:Description */
/* Description: */
/* USERCODE-END:Description */

package at.lcm.x2c.library.control;

import at.lcm.x2c.core.structure.*;
import at.lcm.bu21.general.dtypes.*;

/* USERCODE-BEGIN:Imports */
/* USERCODE-END:Imports */

@SuppressWarnings("unused")
public class ConvFnc_TDSystemO2_Float64 extends JavaConversionFunction {
    private static final long serialVersionUID = 1L;

    @Override
    public void convertMaskToImplementation() throws Exception {
        MaskDouble AMaskVal = (MaskDouble)this.getMaskParameter("A").getMaskDataType();
        TNumeric AMaskData = (TNumeric)AMaskVal.getData();
        double mp_A = AMaskData.getReal(0, 0);
        MaskDouble BMaskVal = (MaskDouble)this.getMaskParameter("B").getMaskDataType();
        TNumeric BMaskData = (TNumeric)BMaskVal.getData();
        double mp_B = BMaskData.getReal(0, 0);

        TNumeric a11CtrVal = this.getImplementationParameterData("a11");
        double cp_a11 = Double.NaN;
        TNumeric a12CtrVal = this.getImplementationParameterData("a12");
        double cp_a12 = Double.NaN;
        TNumeric a21CtrVal = this.getImplementationParameterData("a21");
        double cp_a21 = Double.NaN;
        TNumeric a22CtrVal = this.getImplementationParameterData("a22");
        double cp_a22 = Double.NaN;
        TNumeric b11CtrVal = this.getImplementationParameterData("b11");
        double cp_b11 = Double.NaN;
        TNumeric b12CtrVal = this.getImplementationParameterData("b12");
        double cp_b12 = Double.NaN;
        TNumeric b21CtrVal = this.getImplementationParameterData("b21");
        double cp_b21 = Double.NaN;
        TNumeric b22CtrVal = this.getImplementationParameterData("b22");
        double cp_b22 = Double.NaN;

        /* ATTENTION: */
        /* The M2I conversion function may either use the mp_* or *MaskVal value to get the Mask Parameter value */
        /* For new or updated implementations, the mp_* value shall be used where possible */
        /* Currently, the mp_* value cannot be used for getting non-scalar Mask Parameter data but will return only the first element for these */
        /* The Implementation Parameter assignment variables cp_* can and shall be used for all Implementation Parameter data types */

        /* INFO: Implementation data assignment for array types when using the cp_* variables */
        /* If the cp_* parameter is a FLASH ARRAY, the cp_* variable is assigned an array type but without an actual array */
        /* The M2I conversion function has to assign an array with the correct size and fill it with content */
        /* If the cp_* parameter is a RAM ARRAY, the cp_* variable is assigned an array with the correct size */
        /* The first element is assigned an invalid value while the other elements are (auto)initialized with zero */
        /* The M2I conversion function has to fill the array with content */

        /* Mask parameter values */
        /* mp_A OR AMaskVal (Number) */
        /* mp_B OR BMaskVal (Number) */

        /* USERCODE-BEGIN:ConvMaskToImplementation */
		double[] a = new double[4];
		double[] b = new double[4];

		/* check for correct dimension of matrices */
		if (AMaskData.getNumColumns() != 4) {
			throw new Exception("Matrix A size mismatch");
		}
		if (BMaskData.getNumColumns() != 4) {
			throw new Exception("Matrix B size mismatch");
		}

		/* get controller parameter values */
		for (int i = 0; i < 4; i++) {
			a[i] = AMaskData.getReal(0, i);
			b[i] = BMaskData.getReal(0, i);
		}

		/* set mask parameter values */
		a11CtrVal.setReal(0, 0, a[0]);
		a12CtrVal.setReal(0, 0, a[1]);
		a21CtrVal.setReal(0, 0, a[2]);
		a22CtrVal.setReal(0, 0, a[3]);

		b11CtrVal.setReal(0, 0, b[0]);
		b12CtrVal.setReal(0, 0, b[1]);
		b21CtrVal.setReal(0, 0, b[2]);
		b22CtrVal.setReal(0, 0, b[3]);

        /* USERCODE-END:ConvMaskToImplementation */

        /* Implementation Parameter values */
        /* cp_a11 OR a11CtrVal (Value) */
        /* cp_a12 OR a12CtrVal (Value) */
        /* cp_a21 OR a21CtrVal (Value) */
        /* cp_a22 OR a22CtrVal (Value) */
        /* cp_b11 OR b11CtrVal (Value) */
        /* cp_b12 OR b12CtrVal (Value) */
        /* cp_b21 OR b21CtrVal (Value) */
        /* cp_b22 OR b22CtrVal (Value) */

        if (Double.isNaN(cp_a11)) {
            this.setImplementationParameterData("a11", a11CtrVal);
        } else {
            this.setImplementationParameterData("a11", new TNumeric(cp_a11));
        }
        if (Double.isNaN(cp_a12)) {
            this.setImplementationParameterData("a12", a12CtrVal);
        } else {
            this.setImplementationParameterData("a12", new TNumeric(cp_a12));
        }
        if (Double.isNaN(cp_a21)) {
            this.setImplementationParameterData("a21", a21CtrVal);
        } else {
            this.setImplementationParameterData("a21", new TNumeric(cp_a21));
        }
        if (Double.isNaN(cp_a22)) {
            this.setImplementationParameterData("a22", a22CtrVal);
        } else {
            this.setImplementationParameterData("a22", new TNumeric(cp_a22));
        }
        if (Double.isNaN(cp_b11)) {
            this.setImplementationParameterData("b11", b11CtrVal);
        } else {
            this.setImplementationParameterData("b11", new TNumeric(cp_b11));
        }
        if (Double.isNaN(cp_b12)) {
            this.setImplementationParameterData("b12", b12CtrVal);
        } else {
            this.setImplementationParameterData("b12", new TNumeric(cp_b12));
        }
        if (Double.isNaN(cp_b21)) {
            this.setImplementationParameterData("b21", b21CtrVal);
        } else {
            this.setImplementationParameterData("b21", new TNumeric(cp_b21));
        }
        if (Double.isNaN(cp_b22)) {
            this.setImplementationParameterData("b22", b22CtrVal);
        } else {
            this.setImplementationParameterData("b22", new TNumeric(cp_b22));
        }
    }

    @Override
    public void convertImplementationToMask() throws Exception {
        MaskDouble AMaskVal = (MaskDouble)this.getMaskParameter("A").getMaskDataType();
        TNumeric AMaskData = (TNumeric)AMaskVal.getData();
        double mp_A = Double.NaN;
        MaskDouble BMaskVal = (MaskDouble)this.getMaskParameter("B").getMaskDataType();
        TNumeric BMaskData = (TNumeric)BMaskVal.getData();
        double mp_B = Double.NaN;

        TNumeric a11CtrVal = this.getImplementationParameterData("a11");
        double cp_a11 = a11CtrVal.getReal(0, 0);
        TNumeric a12CtrVal = this.getImplementationParameterData("a12");
        double cp_a12 = a12CtrVal.getReal(0, 0);
        TNumeric a21CtrVal = this.getImplementationParameterData("a21");
        double cp_a21 = a21CtrVal.getReal(0, 0);
        TNumeric a22CtrVal = this.getImplementationParameterData("a22");
        double cp_a22 = a22CtrVal.getReal(0, 0);
        TNumeric b11CtrVal = this.getImplementationParameterData("b11");
        double cp_b11 = b11CtrVal.getReal(0, 0);
        TNumeric b12CtrVal = this.getImplementationParameterData("b12");
        double cp_b12 = b12CtrVal.getReal(0, 0);
        TNumeric b21CtrVal = this.getImplementationParameterData("b21");
        double cp_b21 = b21CtrVal.getReal(0, 0);
        TNumeric b22CtrVal = this.getImplementationParameterData("b22");
        double cp_b22 = b22CtrVal.getReal(0, 0);

        /* ATTENTION: */
        /* The I2M conversion function may either use the cp_* or *CtrlVal value to get the Implementation Parameter value */
        /* For new or updated implementations, the cp_* value shall be used for all Implementation Parameter data types */
        /* The Mask Parameter assignment variables cp_* shall be used where possible */
        /* Currently, the mp_* variable assignment value cannot be used for setting non-scalar Mask Parameter data */

        /* Implementation Parameter values */
        /* cp_a11 OR a11CtrVal (Value) */
        /* cp_a12 OR a12CtrVal (Value) */
        /* cp_a21 OR a21CtrVal (Value) */
        /* cp_a22 OR a22CtrVal (Value) */
        /* cp_b11 OR b11CtrVal (Value) */
        /* cp_b12 OR b12CtrVal (Value) */
        /* cp_b21 OR b21CtrVal (Value) */
        /* cp_b22 OR b22CtrVal (Value) */

        /* USERCODE-BEGIN:ConvImplementationToMask */
		double a[] = new double[4];
		double b[] = new double[4];

		/* get controller parameter values */
		a[0] = a11CtrVal.getReal(0, 0);
		a[1] = a12CtrVal.getReal(0, 0);
		a[2] = a21CtrVal.getReal(0, 0);
		a[3] = a22CtrVal.getReal(0, 0);

		b[0] = b11CtrVal.getReal(0, 0);
		b[1] = b12CtrVal.getReal(0, 0);
		b[2] = b21CtrVal.getReal(0, 0);
		b[3] = b22CtrVal.getReal(0, 0);

		/* set mask parameter values */
		for (int i = 0; i < 4; i++) {
			AMaskData.setReal(0, i, a[i]);
			BMaskData.setReal(0, i, b[i]);
		}

        /* USERCODE-END:ConvImplementationToMask */

        /* Mask parameter values */
        /* mp_A OR AMaskVal (Number) */
        /* mp_B OR BMaskVal (Number) */

        if (Double.isNaN(mp_A)) {
            this.getMaskParameter("A").setValue(AMaskData.toFullString());
        } else {
            this.getMaskParameter("A").setValue(new TNumeric(mp_A).toFullString());
        }
        if (Double.isNaN(mp_B)) {
            this.getMaskParameter("B").setValue(BMaskData.toFullString());
        } else {
            this.getMaskParameter("B").setValue(new TNumeric(mp_B).toFullString());
        }
    }
}
